? dataset.patch
? diffs
? match.sps
? patch
? patch2
? doc/.dirstamp
? lib/gsl-extras/.deps
? lib/gsl-extras/.dirstamp
? lib/gtksheet/.deps
? lib/gtksheet/.dirstamp
? lib/linreg/.deps
? lib/linreg/.dirstamp
? m4/Makefile.am
? m4/codeset.m4
? m4/gettext.m4
? m4/glibc2.m4
? m4/glibc21.m4
? m4/iconv.m4
? m4/intdiv0.m4
? m4/intmax.m4
? m4/inttypes-pri.m4
? m4/inttypes.m4
? m4/inttypes_h.m4
? m4/isc-posix.m4
? m4/lcmessage.m4
? m4/lib-ld.m4
? m4/lib-link.m4
? m4/lib-prefix.m4
? m4/longdouble.m4
? m4/longlong.m4
? m4/nls.m4
? m4/po.m4
? m4/printf-posix.m4
? m4/progtest.m4
? m4/signed.m4
? m4/size_max.m4
? m4/stdint_h.m4
? m4/uintmax_t.m4
? m4/ulonglong.m4
? m4/wchar_t.m4
? m4/wint_t.m4
? m4/xsize.m4
? src/data/.deps
? src/data/.dirstamp
? src/data/st6l7zc9
? src/language/.deps
? src/language/.dirstamp
? src/language/control/.deps
? src/language/control/.dirstamp
? src/language/data-io/.deps
? src/language/data-io/.dirstamp
? src/language/data-io/file-handle.c
? src/language/data-io/list.c
? src/language/dictionary/.deps
? src/language/dictionary/.dirstamp
? src/language/expressions/.deps
? src/language/expressions/.dirstamp
? src/language/lexer/.deps
? src/language/lexer/.dirstamp
? src/language/lexer/q2c
? src/language/stats/.deps
? src/language/stats/.dirstamp
? src/language/stats/correlations.c
? src/language/stats/crosstabs.c
? src/language/stats/examine.c
? src/language/stats/frequencies.c
? src/language/stats/means.c
? src/language/stats/oneway.c
? src/language/stats/rank.c
? src/language/stats/regression.c
? src/language/stats/t-test.c
? src/language/tests/.deps
? src/language/tests/.dirstamp
? src/language/utilities/.deps
? src/language/utilities/.dirstamp
? src/language/utilities/set.c
? src/language/xforms/.deps
? src/language/xforms/.dirstamp
? src/libpspp/.deps
? src/libpspp/.dirstamp
? src/libpspp/version.c
? src/math/.deps
? src/math/.dirstamp
? src/math/linreg/.deps
? src/math/linreg/.dirstamp
? src/math/ts/.deps
? src/math/ts/.dirstamp
? src/output/.deps
? src/output/.dirstamp
? src/output/charts/.deps
? src/output/charts/.dirstamp
? src/ui/.deps
? src/ui/.dirstamp
? src/ui/gui/.deps
? src/ui/gui/.dirstamp
? src/ui/gui/psppire
? src/ui/terminal/.deps
? src/ui/terminal/.dirstamp
? src/ui/terminal/pspp
? tests/libpspp/.deps
? tests/libpspp/.dirstamp
? tests/libpspp/ll-test
? tests/libpspp/llx-test
Index: src/data/dictionary.c
===================================================================
RCS file: /sources/pspp/pspp/src/data/dictionary.c,v
retrieving revision 1.15
diff -b -w -U3 -r1.15 dictionary.c
--- src/data/dictionary.c	19 Oct 2006 15:04:52 -0000	1.15
+++ src/data/dictionary.c	25 Oct 2006 22:52:34 -0000
@@ -435,8 +435,8 @@
 /* Deletes variable V from dictionary D and frees V.
 
    This is a very bad idea if there might be any pointers to V
-   from outside D.  In general, no variable in current_dataset->dict
-   should be deleted when any transformations are active, because
+   from outside D.  In general, no variable in should be deleted when 
+   any transformations are active on the dictionary's dataset, because
    those transformations might reference the deleted variable.
    The safest time to delete a variable is just after a procedure
    has been executed, as done by MODIFY VARS.
Index: src/data/procedure.c
===================================================================
RCS file: /sources/pspp/pspp/src/data/procedure.c,v
retrieving revision 1.14
diff -b -w -U3 -r1.14 procedure.c
--- src/data/procedure.c	19 Oct 2006 15:04:52 -0000	1.14
+++ src/data/procedure.c	25 Oct 2006 22:52:34 -0000
@@ -88,13 +88,11 @@
 }; /* struct dataset */
 
 
-struct dataset *current_dataset;
-
 static void add_case_limit_trns (struct dataset *ds);
 static void add_filter_trns (struct dataset *ds);
 
 static bool internal_procedure (struct dataset *ds, case_func_t,
-                                bool (*end_func) (void *),
+                                end_func_t,
                                 void *aux);
 static void update_last_proc_invocation (struct dataset *ds);
 static void create_trns_case (struct ccase *, struct dictionary *);
@@ -152,7 +150,7 @@
 
 /* Case processing function for multipass_procedure(). */
 static bool
-multipass_case_func (const struct ccase *c, void *aux_data_) 
+multipass_case_func (const struct ccase *c, void *aux_data_, const struct dataset *ds UNUSED) 
 {
   struct multipass_aux_data *aux_data = aux_data_;
   return casefile_append (aux_data->casefile, c);
@@ -160,7 +158,7 @@
 
 /* End-of-file function for multipass_procedure(). */
 static bool
-multipass_end_func (void *aux_data_) 
+multipass_end_func (void *aux_data_, const struct dataset *ds UNUSED) 
 {
   struct multipass_aux_data *aux_data = aux_data_;
   return (aux_data->proc_func == NULL
@@ -198,7 +196,7 @@
    if CASE_FUNC or END_FUNC ever returned false). */
 static bool
 internal_procedure (struct dataset *ds, case_func_t case_func,
-                    bool (*end_func) (void *),
+		    end_func_t end_func,
                     void *aux) 
 {
   struct write_case_data wc_data;
@@ -237,7 +235,7 @@
                                  &wc_data.trns_case,
                                  write_case, &wc_data) && ok;
   if (end_func != NULL)
-    ok = end_func (aux) && ok;
+    ok = end_func (aux, ds) && ok;
 
   case_destroy (&wc_data.sink_case);
   case_destroy (&wc_data.trns_case);
@@ -366,7 +364,7 @@
 
   /* Pass case to procedure. */
   if (wc_data->case_func != NULL)
-    if (!wc_data->case_func (&wc_data->trns_case, wc_data->aux))
+    if (!wc_data->case_func (&wc_data->trns_case, wc_data->aux, ds))
       retval = TRNS_ERROR;
 
  done:
@@ -478,13 +476,13 @@
     /* Callback functions. */
     begin_func_t begin_func ; 
     case_func_t proc_func ;
-    void (*end_func) (void *);
+    end_func_t end_func;
     void *func_aux;
   };
 
 static int equal_splits (const struct ccase *, const struct ccase *, const struct dataset *ds);
-static bool split_procedure_case_func (const struct ccase *c, void *);
-static bool split_procedure_end_func (void *);
+static bool split_procedure_case_func (const struct ccase *c, void *, const struct dataset *);
+static bool split_procedure_end_func (void *, const struct dataset *);
 
 /* Like procedure(), but it automatically breaks the case stream
    into SPLIT FILE break groups.  Before each group of cases with
@@ -507,7 +505,7 @@
 procedure_with_splits (struct dataset *ds,
 		       begin_func_t begin_func, 
 		       case_func_t proc_func,
-                       void (*end_func) (void *aux),
+                       end_func_t end_func,
                        void *func_aux) 
 {
   struct split_aux_data split_aux;
@@ -530,7 +528,7 @@
 
 /* Case callback used by procedure_with_splits(). */
 static bool
-split_procedure_case_func (const struct ccase *c, void *split_aux_) 
+split_procedure_case_func (const struct ccase *c, void *split_aux_, const struct dataset *ds) 
 {
   struct split_aux_data *split_aux = split_aux_;
 
@@ -539,28 +537,28 @@
       || !equal_splits (c, &split_aux->prev_case, split_aux->dataset))
     {
       if (!case_is_null (&split_aux->prev_case) && split_aux->end_func != NULL)
-        split_aux->end_func (split_aux->func_aux);
+        split_aux->end_func (split_aux->func_aux, ds);
 
       case_destroy (&split_aux->prev_case);
       case_clone (&split_aux->prev_case, c);
 
       if (split_aux->begin_func != NULL)
-	split_aux->begin_func (&split_aux->prev_case, split_aux->func_aux);
+	split_aux->begin_func (&split_aux->prev_case, split_aux->func_aux, ds);
 
     }
 
   return (split_aux->proc_func == NULL
-          || split_aux->proc_func (c, split_aux->func_aux));
+          || split_aux->proc_func (c, split_aux->func_aux, ds));
 }
 
 /* End-of-file callback used by procedure_with_splits(). */
 static bool
-split_procedure_end_func (void *split_aux_) 
+split_procedure_end_func (void *split_aux_, const struct dataset *ds) 
 {
   struct split_aux_data *split_aux = split_aux_;
 
   if (!case_is_null (&split_aux->prev_case) && split_aux->end_func != NULL)
-    split_aux->end_func (split_aux->func_aux);
+    split_aux->end_func (split_aux->func_aux, ds);
   return true;
 }
 
@@ -586,22 +584,20 @@
     struct ccase prev_case;     /* Data in previous case. */
     struct casefile *casefile;  /* Accumulates data for a split. */
 
-    /* Function to call with the accumulated data. */
-    bool (*split_func) (const struct ccase *first, const struct casefile *,
-                        void *);
+    split_func_t split_func;    /* Function to call with the accumulated 
+				   data. */
+
     void *func_aux;                            /* Auxiliary data. */ 
   };
 
-static bool multipass_split_case_func (const struct ccase *c, void *aux_);
-static bool multipass_split_end_func (void *aux_);
-static bool multipass_split_output (struct multipass_split_aux_data *);
+static bool multipass_split_case_func (const struct ccase *c, void *aux_, const struct dataset *);
+static bool multipass_split_end_func (void *aux_, const struct dataset *ds);
+static bool multipass_split_output (struct multipass_split_aux_data *, const struct dataset *ds);
 
 /* Returns true if successful, false if an I/O error occurred. */
 bool
 multipass_procedure_with_splits (struct dataset *ds, 
-				 bool (*split_func) (const struct ccase *first,
-                                                     const struct casefile *,
-                                                     void *aux),
+				 split_func_t split_func,
                                  void *func_aux)
 {
   struct multipass_split_aux_data aux;
@@ -622,10 +618,9 @@
 
 /* Case callback used by multipass_procedure_with_splits(). */
 static bool
-multipass_split_case_func (const struct ccase *c, void *aux_)
+multipass_split_case_func (const struct ccase *c, void *aux_, const struct dataset *ds)
 {
   struct multipass_split_aux_data *aux = aux_;
-  struct dataset *ds = aux->dataset;
   bool ok = true;
 
   /* Start a new series if needed. */
@@ -637,7 +632,7 @@
 
       /* Pass any cases to split_func. */
       if (aux->casefile != NULL)
-        ok = multipass_split_output (aux);
+        ok = multipass_split_output (aux, ds);
 
       /* Start a new casefile. */
       aux->casefile = 
@@ -649,19 +644,19 @@
 
 /* End-of-file callback used by multipass_procedure_with_splits(). */
 static bool
-multipass_split_end_func (void *aux_)
+multipass_split_end_func (void *aux_, const struct dataset *ds)
 {
   struct multipass_split_aux_data *aux = aux_;
-  return (aux->casefile == NULL || multipass_split_output (aux));
+  return (aux->casefile == NULL || multipass_split_output (aux, ds));
 }
 
 static bool
-multipass_split_output (struct multipass_split_aux_data *aux)
+multipass_split_output (struct multipass_split_aux_data *aux, const struct dataset *ds)
 {
   bool ok;
   
   assert (aux->casefile != NULL);
-  ok = aux->split_func (&aux->prev_case, aux->casefile, aux->func_aux);
+  ok = aux->split_func (&aux->prev_case, aux->casefile, aux->func_aux, ds);
   casefile_destroy (aux->casefile);
   aux->casefile = NULL;
 
Index: src/data/procedure.h
===================================================================
RCS file: /sources/pspp/pspp/src/data/procedure.h,v
retrieving revision 1.5
diff -b -w -U3 -r1.5 procedure.h
--- src/data/procedure.h	19 Oct 2006 15:04:52 -0000	1.5
+++ src/data/procedure.h	25 Oct 2006 22:52:34 -0000
@@ -69,8 +69,13 @@
 struct casefile *proc_capture_output (struct dataset *ds);
 
 typedef bool (*casefile_func_t) (const struct casefile *, void *);
-typedef bool (*case_func_t) (const struct ccase *, void *);
-typedef void (*begin_func_t) (const struct ccase *, void *);
+typedef bool (*case_func_t) (const struct ccase *, void *, const struct dataset *);
+typedef void (*begin_func_t) (const struct ccase *, void *, const struct dataset*);
+
+typedef bool (*end_func_t) (void *, const struct dataset *);
+
+typedef bool (*split_func_t) (const struct ccase *, const struct casefile *,
+			      void *, const struct dataset *);
 
 
 
@@ -79,15 +84,13 @@
 bool procedure_with_splits (struct dataset *ds, 
 			    begin_func_t begin_func,
                             case_func_t proc_func,
-                            void (*end_func) (void *),
+			    end_func_t end_func,
                             void *aux)
      WARN_UNUSED_RESULT;
 bool multipass_procedure (struct dataset *ds, casefile_func_t, void  *aux)
      WARN_UNUSED_RESULT;
 bool multipass_procedure_with_splits (struct dataset *ds,
-					   bool (*) (const struct ccase *,
-						     const struct casefile *,
-						     void *),
+					   split_func_t,
 					   void *aux)
      WARN_UNUSED_RESULT;
 
@@ -98,8 +101,6 @@
 
 struct ccase *lagged_case (const struct dataset *ds, int n_before);
 
-extern struct dataset *current_dataset;
-
 inline struct dictionary *dataset_dict (const struct dataset *ds);
 inline void dataset_set_dict ( struct dataset *ds, struct dictionary *dict);
 
Index: src/language/command.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/command.c,v
retrieving revision 1.17
diff -b -w -U3 -r1.17 command.c
--- src/language/command.c	19 Oct 2006 15:04:52 -0000	1.17
+++ src/language/command.c	25 Oct 2006 22:52:34 -0000
@@ -108,7 +108,7 @@
     enum states states;         /* States in which command is allowed. */
     enum flags flags;           /* Other command requirements. */
     const char *name;		/* Command name. */
-    int (*function) (void);	/* Function to call. */
+    int (*function) (struct dataset *);	/* Function to call. */
   };
 
 /* Define the command array. */
@@ -131,24 +131,24 @@
 /* Command parser. */
 
 static const struct command *parse_command_name (void);
-static enum cmd_result do_parse_command (enum cmd_state);
+static enum cmd_result do_parse_command (struct dataset *ds, enum cmd_state);
 
 /* Parses an entire command, from command name to terminating
    dot.  On failure, skips to the terminating dot.
    Returns the command's success or failure result. */
 enum cmd_result
-cmd_parse (enum cmd_state state) 
+cmd_parse (struct dataset *ds, enum cmd_state state) 
 {
   int result;
   
   som_new_series ();
 
-  result = do_parse_command (state);
+  result = do_parse_command (ds, state);
   if (cmd_result_is_failure (result)) 
     lex_discard_rest_of_command ();
 
   unset_cmd_algorithm ();
-  dict_clear_aux (dataset_dict (current_dataset));
+  dict_clear_aux (dataset_dict (ds));
 
   return result;
 }
@@ -156,7 +156,7 @@
 /* Parses an entire command, from command name to terminating
    dot. */
 static enum cmd_result
-do_parse_command (enum cmd_state state)
+do_parse_command (struct dataset *ds, enum cmd_state state)
 {
   const struct command *command;
   enum cmd_result result;
@@ -203,7 +203,7 @@
   /* Execute command. */
   msg_set_command_name (command->name);
   tab_set_command_name (command->name);
-  result = command->function ();
+  result = command->function (ds);
   tab_set_command_name (NULL);
   msg_set_command_name (NULL);
     
@@ -649,14 +649,14 @@
 
 /* Parse and execute FINISH command. */
 int
-cmd_finish (void)
+cmd_finish (struct dataset *ds UNUSED)
 {
   return CMD_FINISH;
 }
 
 /* Parses the N command. */
 int
-cmd_n_of_cases (void)
+cmd_n_of_cases (struct dataset *ds)
 {
   /* Value for N. */
   int x;
@@ -666,23 +666,23 @@
   x = lex_integer ();
   lex_get ();
   if (!lex_match_id ("ESTIMATED"))
-    dict_set_case_limit (dataset_dict (current_dataset), x);
+    dict_set_case_limit (dataset_dict (ds), x);
 
   return lex_end_of_command ();
 }
 
 /* Parses, performs the EXECUTE procedure. */
 int
-cmd_execute (void)
+cmd_execute (struct dataset *ds)
 {
-  if (!procedure (current_dataset,NULL, NULL))
+  if (!procedure (ds, NULL, NULL))
     return CMD_CASCADING_FAILURE;
   return lex_end_of_command ();
 }
 
 /* Parses, performs the ERASE command. */
 int
-cmd_erase (void)
+cmd_erase (struct dataset *ds UNUSED)
 {
   if (get_safer_mode ()) 
     { 
@@ -811,7 +811,7 @@
 
 /* Parses, performs the HOST command. */
 int
-cmd_host (void)
+cmd_host (struct dataset *ds UNUSED)
 {
   int code;
 
@@ -848,16 +848,16 @@
 
 /* Parses, performs the NEW FILE command. */
 int
-cmd_new_file (void)
+cmd_new_file (struct dataset *ds)
 {
-  discard_variables (current_dataset);
+  discard_variables (ds);
 
   return lex_end_of_command ();
 }
 
 /* Parses a comment. */
 int
-cmd_comment (void)
+cmd_comment (struct dataset *ds UNUSED)
 {
   lex_skip_comment ();
   return CMD_SUCCESS;
Index: src/language/command.h
===================================================================
RCS file: /sources/pspp/pspp/src/language/command.h,v
retrieving revision 1.5
diff -b -w -U3 -r1.5 command.h
--- src/language/command.h	28 Jun 2006 05:49:03 -0000	1.5
+++ src/language/command.h	25 Oct 2006 22:52:34 -0000
@@ -54,13 +54,16 @@
     CMD_STATE_FILE_TYPE         /* Inside FILE TYPE. */
   };
 
-enum cmd_result cmd_parse (enum cmd_state);
+struct dataset;
+enum cmd_result cmd_parse (struct dataset *ds, enum cmd_state);
 
 struct command;
 const char *cmd_complete (const char *, const struct command **);
 
+struct dataset;
+
 /* Prototype all the command functions. */
-#define DEF_CMD(STATES, FLAGS, NAME, FUNCTION) int FUNCTION (void);
+#define DEF_CMD(STATES, FLAGS, NAME, FUNCTION) int FUNCTION (struct dataset *);
 #define UNIMPL_CMD(NAME, DESCRIPTION)
 #include "command.def"
 #undef DEF_CMD
Index: src/language/control/control-stack.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/control/control-stack.c,v
retrieving revision 1.5
diff -b -w -U3 -r1.5 control-stack.c
--- src/language/control/control-stack.c	22 Oct 2006 11:07:52 -0000	1.5
+++ src/language/control/control-stack.c	25 Oct 2006 22:52:34 -0000
@@ -75,7 +75,7 @@
 }
 
 void
-ctl_stack_pop (void *private UNUSED) 
+ctl_stack_pop (void *private) 
 {
   struct ctl_struct *top = ctl_stack;
   
Index: src/language/control/do-if.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/control/do-if.c,v
retrieving revision 1.8
diff -b -w -U3 -r1.8 do-if.c
--- src/language/control/do-if.c	22 Oct 2006 11:07:52 -0000	1.8
+++ src/language/control/do-if.c	25 Oct 2006 22:52:34 -0000
@@ -75,6 +75,7 @@
 /* DO IF transformation. */
 struct do_if_trns
   {
+    struct dataset *ds;         /* The dataset */
     struct clause *clauses;     /* Clauses. */
     size_t clause_cnt;          /* Number of clauses. */
     int past_END_IF_index;      /* Transformation just past last clause. */
@@ -82,7 +83,7 @@
 
 static const struct ctl_class do_if_class;
 
-static int parse_clause (struct do_if_trns *);
+static int parse_clause (struct do_if_trns *, struct dataset *ds);
 static void add_clause (struct do_if_trns *,
                         struct expression *condition, int target_index);
 static void add_else (struct do_if_trns *);
@@ -97,34 +98,36 @@
 
 /* Parse DO IF. */
 int
-cmd_do_if (void)
+cmd_do_if (struct dataset *ds)
 {
   struct do_if_trns *do_if = xmalloc (sizeof *do_if);
   do_if->clauses = NULL;
   do_if->clause_cnt = 0;
+  do_if->ds = ds;
 
   ctl_stack_push (&do_if_class, do_if);
-  add_transformation_with_finalizer (current_dataset, do_if_finalize_func,
+  add_transformation_with_finalizer (ds, do_if_finalize_func,
                                      do_if_trns_proc, do_if_trns_free, do_if);
 
-  return parse_clause (do_if);
+  return parse_clause (do_if, ds);
 }
 
 /* Parse ELSE IF. */
 int
-cmd_else_if (void)
+cmd_else_if (struct dataset *ds)
 {
   struct do_if_trns *do_if = ctl_stack_top (&do_if_class);
   if (do_if == NULL || !must_not_have_else (do_if))
     return CMD_CASCADING_FAILURE;
-  return parse_clause (do_if);
+  return parse_clause (do_if, ds);
 }
 
 /* Parse ELSE. */
 int
-cmd_else (void)
+cmd_else (struct dataset *ds)
 {
   struct do_if_trns *do_if = ctl_stack_top (&do_if_class);
+  assert (ds == do_if->ds);
   if (do_if == NULL || !must_not_have_else (do_if))
     return CMD_CASCADING_FAILURE;
   add_else (do_if);
@@ -133,9 +136,11 @@
 
 /* Parse END IF. */
 int
-cmd_end_if (void)
+cmd_end_if (struct dataset *ds)
 {
   struct do_if_trns *do_if = ctl_stack_top (&do_if_class);
+  assert (ds == do_if->ds);
+
   if (do_if == NULL)
     return CMD_CASCADING_FAILURE;
 
@@ -153,7 +158,7 @@
   
   if (!has_else (do_if)) 
     add_else (do_if);
-  do_if->past_END_IF_index = next_transformation (current_dataset);
+  do_if->past_END_IF_index = next_transformation (do_if->ds);
 }
 
 /* Adds an ELSE clause to DO_IF pointing to the next
@@ -162,7 +167,7 @@
 add_else (struct do_if_trns *do_if) 
 {
   assert (!has_else (do_if));
-  add_clause (do_if, NULL, next_transformation (current_dataset));
+  add_clause (do_if, NULL, next_transformation (do_if->ds));
 }
 
 /* Returns true if DO_IF does not yet have an ELSE clause.
@@ -192,15 +197,15 @@
    corresponding clause to DO_IF.  Checks for end of command and
    returns a command return code. */
 static int
-parse_clause (struct do_if_trns *do_if)
+parse_clause (struct do_if_trns *do_if, struct dataset *ds)
 {
   struct expression *condition;
 
-  condition = expr_parse (dataset_dict (current_dataset), EXPR_BOOLEAN);
+  condition = expr_parse (ds, EXPR_BOOLEAN);
   if (condition == NULL)
     return CMD_CASCADING_FAILURE;
 
-  add_clause (do_if, condition, next_transformation (current_dataset));
+  add_clause (do_if, condition, next_transformation (ds));
 
   return lex_end_of_command ();
 }
@@ -214,7 +219,7 @@
   struct clause *clause;
 
   if (do_if->clause_cnt > 0)
-    add_transformation (current_dataset, break_trns_proc, NULL, do_if);
+    add_transformation (do_if->ds, break_trns_proc, NULL, do_if);
 
   do_if->clauses = xnrealloc (do_if->clauses,
                               do_if->clause_cnt + 1, sizeof *do_if->clauses);
Index: src/language/control/loop.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/control/loop.c,v
retrieving revision 1.9
diff -b -w -U3 -r1.9 loop.c
--- src/language/control/loop.c	22 Oct 2006 11:07:52 -0000	1.9
+++ src/language/control/loop.c	25 Oct 2006 22:52:35 -0000
@@ -58,6 +58,7 @@
 struct loop_trns
   {
     struct pool *pool;
+    struct dataset *ds;
 
     /* Iteration limit. */
     int max_pass_count;         /* Maximum number of passes (-1=unlimited). */
@@ -85,7 +86,7 @@
 static trns_proc_func loop_trns_proc, end_loop_trns_proc, break_trns_proc;
 static trns_free_func loop_trns_free;
 
-static struct loop_trns *create_loop_trns (void);
+static struct loop_trns *create_loop_trns (struct dataset *);
 static bool parse_if_clause (struct loop_trns *, struct expression **);
 static bool parse_index_clause (struct loop_trns *, char index_var_name[]);
 static void close_loop (void *);
@@ -94,13 +95,13 @@
 
 /* Parses LOOP. */
 int
-cmd_loop (void)
+cmd_loop (struct dataset *ds)
 {
   struct loop_trns *loop;
   char index_var_name[LONG_NAME_LEN + 1];
   bool ok = true;
 
-  loop = create_loop_trns ();
+  loop = create_loop_trns (ds);
   while (token != '.' && ok) 
     {
       if (lex_match_id ("IF")) 
@@ -112,9 +113,10 @@
   /* Find index variable and create if necessary. */
   if (ok && index_var_name[0] != '\0')
     {
-      loop->index_var = dict_lookup_var (dataset_dict (current_dataset), index_var_name);
+      loop->index_var = dict_lookup_var (dataset_dict (ds), index_var_name);
       if (loop->index_var == NULL)
-        loop->index_var = dict_create_var (dataset_dict (current_dataset), index_var_name, 0);
+        loop->index_var = dict_create_var (dataset_dict (ds), 
+					   index_var_name, 0);
     }
   
   if (!ok)
@@ -124,7 +126,7 @@
 
 /* Parses END LOOP. */
 int
-cmd_end_loop (void)
+cmd_end_loop (struct dataset *ds)
 {
   struct loop_trns *loop;
   bool ok = true;
@@ -133,6 +135,8 @@
   if (loop == NULL)
     return CMD_CASCADING_FAILURE;
   
+  assert (loop->ds == ds);
+  
   /* Parse syntax. */
   if (lex_match_id ("IF"))
     ok = parse_if_clause (loop, &loop->end_loop_condition);
@@ -149,13 +153,13 @@
 
 /* Parses BREAK. */
 int
-cmd_break (void)
+cmd_break (struct dataset *ds)
 {
   struct ctl_stmt *loop = ctl_stack_search (&loop_class);
   if (loop == NULL)
     return CMD_CASCADING_FAILURE;
 
-  add_transformation (current_dataset, break_trns_proc, NULL, loop);
+  add_transformation (ds, break_trns_proc, NULL, loop);
 
   return lex_end_of_command ();
 }
@@ -167,8 +171,8 @@
 {
   struct loop_trns *loop = loop_;
   
-  add_transformation (current_dataset, end_loop_trns_proc, NULL, loop);
-  loop->past_END_LOOP_index = next_transformation (current_dataset);
+  add_transformation (loop->ds, end_loop_trns_proc, NULL, loop);
+  loop->past_END_LOOP_index = next_transformation (loop->ds);
 
   /* If there's nothing else limiting the number of loops, use
      MXLOOPS as a limit. */
@@ -185,7 +189,7 @@
 static bool
 parse_if_clause (struct loop_trns *loop, struct expression **condition) 
 {
-  *condition = expr_parse_pool (loop->pool, dataset_dict (current_dataset), EXPR_BOOLEAN);
+  *condition = expr_parse_pool (loop->pool, loop->ds, EXPR_BOOLEAN);
   return *condition != NULL;
 }
 
@@ -206,7 +210,7 @@
   if (!lex_force_match ('='))
     return false;
 
-  loop->first_expr = expr_parse_pool (loop->pool, dataset_dict (current_dataset), EXPR_NUMBER);
+  loop->first_expr = expr_parse_pool (loop->pool, loop->ds, EXPR_NUMBER);
   if (loop->first_expr == NULL)
     return false;
 
@@ -225,7 +229,7 @@
           lex_sbc_only_once (e == &loop->last_expr ? "TO" : "BY");
           return false;
         }
-      *e = expr_parse_pool (loop->pool, dataset_dict (current_dataset), EXPR_NUMBER);
+      *e = expr_parse_pool (loop->pool, loop->ds, EXPR_NUMBER);
       if (*e == NULL)
         return false;
     }
@@ -242,7 +246,7 @@
 
 /* Creates, initializes, and returns a new loop_trns. */
 static struct loop_trns *
-create_loop_trns (void) 
+create_loop_trns (struct dataset *ds) 
 {
   struct loop_trns *loop = pool_create_container (struct loop_trns, pool);
   loop->max_pass_count = -1;
@@ -250,10 +254,11 @@
   loop->index_var = NULL;
   loop->first_expr = loop->by_expr = loop->last_expr = NULL;
   loop->loop_condition = loop->end_loop_condition = NULL;
+  loop->ds = ds;
 
-  add_transformation_with_finalizer (current_dataset, loop_trns_finalize,
+  add_transformation_with_finalizer (ds, loop_trns_finalize,
                                      loop_trns_proc, loop_trns_free, loop);
-  loop->past_LOOP_index = next_transformation (current_dataset);
+  loop->past_LOOP_index = next_transformation (ds);
 
   ctl_stack_push (&loop_class, loop);
 
Index: src/language/control/repeat.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/control/repeat.c,v
retrieving revision 1.12
diff -b -w -U3 -r1.12 repeat.c
--- src/language/control/repeat.c	19 Oct 2006 15:04:53 -0000	1.12
+++ src/language/control/repeat.c	25 Oct 2006 22:52:35 -0000
@@ -74,6 +74,7 @@
 struct repeat_block 
   {
     struct pool *pool;                  /* Pool used for storage. */
+    struct dataset *ds;                 /* The dataset for this block */
     struct line_list *first_line;       /* First line in line buffer. */
     struct line_list *cur_line;         /* Current line in line buffer. */
     int loop_cnt;                       /* Number of loops. */
@@ -86,7 +87,7 @@
 static bool parse_lines (struct repeat_block *);
 static void create_vars (struct repeat_block *);
 
-static int parse_ids (struct repeat_entry *, struct pool *);
+static int parse_ids (const struct dictionary *dict, struct repeat_entry *, struct pool *);
 static int parse_numbers (struct repeat_entry *, struct pool *);
 static int parse_strings (struct repeat_entry *, struct pool *);
 
@@ -96,11 +97,12 @@
 static void do_repeat_close (void *block);
 
 int
-cmd_do_repeat (void)
+cmd_do_repeat (struct dataset *ds)
 {
   struct repeat_block *block;
 
   block = pool_create_container (struct repeat_block, pool);
+  block->ds = ds;
 
   if (!parse_specification (block) || !parse_lines (block))
     goto error;
@@ -132,12 +134,13 @@
     {
       struct repeat_entry *e;
       struct repeat_entry *iter;
+      struct dictionary *dict = dataset_dict (block->ds);
       int count;
 
       /* Get a stand-in variable name and make sure it's unique. */
       if (!lex_force_id ())
 	return false;
-      if (dict_lookup_var (dataset_dict (current_dataset), tokid))
+      if (dict_lookup_var (dict, tokid))
         msg (SW, _("Dummy variable name \"%s\" hides dictionary "
                    "variable \"%s\"."),
              tokid, tokid);
@@ -162,7 +165,7 @@
 
       /* Get the details of the variable's possible values. */
       if (token == T_ID)
-	count = parse_ids (e, block->pool);
+	count = parse_ids (dict, e, block->pool);
       else if (lex_is_number ())
 	count = parse_numbers (e, block->pool);
       else if (token == T_STRING)
@@ -331,18 +334,18 @@
           {
             /* Ignore return value: if the variable already
                exists there is no harm done. */
-            dict_create_var (dataset_dict (current_dataset), iter->replacement[i], 0);
+            dict_create_var (dataset_dict (block->ds), iter->replacement[i], 0);
           }
       }
 }
 
 /* Parses a set of ids for DO REPEAT. */
 static int
-parse_ids (struct repeat_entry *e, struct pool *pool)
+parse_ids (const struct dictionary *dict, struct repeat_entry *e, struct pool *pool)
 {
   size_t n = 0;
   e->type = VAR_NAMES;
-  return parse_mixed_vars_pool (pool, &e->replacement, &n, PV_NONE) ? n : 0;
+  return parse_mixed_vars_pool (dict, pool, &e->replacement, &n, PV_NONE) ? n : 0;
 }
 
 /* Adds STRING to E's list of replacements, which has *USED
@@ -440,7 +443,7 @@
 }
 
 int
-cmd_end_repeat (void)
+cmd_end_repeat (struct dataset *ds UNUSED)
 {
   msg (SE, _("No matching DO REPEAT."));
   return CMD_CASCADING_FAILURE;
Index: src/language/control/temporary.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/control/temporary.c,v
retrieving revision 1.5
diff -b -w -U3 -r1.5 temporary.c
--- src/language/control/temporary.c	19 Oct 2006 15:04:53 -0000	1.5
+++ src/language/control/temporary.c	25 Oct 2006 22:52:35 -0000
@@ -41,10 +41,10 @@
 
 /* Parses the TEMPORARY command. */
 int
-cmd_temporary (void)
+cmd_temporary (struct dataset *ds)
 {
-  if (!proc_in_temporary_transformations (current_dataset))
-    proc_start_temporary_transformations (current_dataset);
+  if (!proc_in_temporary_transformations (ds))
+    proc_start_temporary_transformations (ds);
   else
     msg (SE, _("This command may only appear once between "
                "procedures and procedure-like commands."));
